
data {
   
   int<lower=0> n;
   int<lower=0> p;
   matrix[n,1] y;
   matrix[n,1+p] X;
   matrix[n,1] y_dense;
   real mu_beta;
   real<lower=0> beta_s;
   real<lower=0> sig_p1;
   real<lower=0> sig_p2;
   real<lower=0> w;
}

parameters 
{
   
vector[p+1] beta;
real<lower=0> sigma2;

}

model {
  
sigma2 ~ inv_gamma(sig_p1,sig_p2);
beta ~ normal(mu_beta,sqrt((sigma2*beta_s)));

for(i in 1:n){
  increment_log_prob(sqrt(exp(normal_log(y[i,1],X[i,]*beta,sqrt(sigma2))))/sqrt(y_dense[i,1]));
}
}

