
data {
   
   int<lower=0> n;
   vector[n] y;
   vector[n] y_dense;
   real mu_m;
   real<lower=0> mu_s;
   real<lower=0> sig_p1;
   real<lower=0> sig_p2;
   real<lower=0> w;

}

parameters 
{
   
real mu;

real<lower=0> sigma;

}

model {
    
mu ~ normal(mu_m,mu_s);
sigma ~ gamma(sig_p1,sig_p2);
for(i in 1:n){

  #increment_log_prob( sqrt((1/(sqrt(2*pi())*sigma))*exp(-0.5*(y[i]-mu)^2/sigma^2))/sqrt(y_dense[i]));
  increment_log_prob( w*(sqrt(exp(normal_log(y[i],mu,sigma)))/sqrt(y_dense[i])));
}
}
	
	generated quantities {
 real y_predict;
 y_predict = normal_rng(mu,sigma);

}
